unit schUsuariosServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schUsuariosClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_USUARIOSDelta = '{B2CDE2B6-AEA1-4FA3-915F-D16D39393C56}';
  RID_USUARIOS_EVENTOSDelta = '{A9C5CC49-68FB-44C9-82E1-E91B7635E443}';
  RID_USUARIOS_LOGONDelta = '{94752363-8D31-4796-A289-07D791FC4A04}';
  RID_PERMISOSDelta = '{0C3EFDD0-E026-41A9-8411-F879524DC1F6}';
  RID_PERMISOSEXDelta = '{02B025FC-0CFE-41D3-93CF-65E9659AB816}';
  RID_PERFILESDelta = '{00782C74-631D-4032-8177-FBA0607AA4DD}';

type
  { IUSUARIOSDelta }
  IUSUARIOSDelta = interface(IUSUARIOS)
  ['{B2CDE2B6-AEA1-4FA3-915F-D16D39393C56}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldUSERNAMEValue : String;
    function GetOldLOGINValue : String;
    function GetOldPASSValue : String;
    function GetOldPASSEXPIREDValue : DateTime;
    function GetOldBLOQUEADOValue : SmallInt;
    function GetOldEMAILValue : String;
    function GetOldUSERDAYSSUNValue : Integer;
    function GetOldPRIVILEGEDValue : Integer;
    function GetOldTIPOValue : String;
    function GetOldID_PERFILValue : Integer;
    function GetOldCHECKSUMValue : String;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldUSERNAME : String read GetOldUSERNAMEValue;
    property OldLOGIN : String read GetOldLOGINValue;
    property OldPASS : String read GetOldPASSValue;
    property OldPASSEXPIRED : DateTime read GetOldPASSEXPIREDValue;
    property OldBLOQUEADO : SmallInt read GetOldBLOQUEADOValue;
    property OldEMAIL : String read GetOldEMAILValue;
    property OldUSERDAYSSUN : Integer read GetOldUSERDAYSSUNValue;
    property OldPRIVILEGED : Integer read GetOldPRIVILEGEDValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldID_PERFIL : Integer read GetOldID_PERFILValue;
    property OldCHECKSUM : String read GetOldCHECKSUMValue;
  end;

  { TUSUARIOSBusinessProcessorRules }
  TUSUARIOSBusinessProcessorRules = class(TDABusinessProcessorRules, IUSUARIOS, IUSUARIOSDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetUSERNAMEValue: String; virtual;
    function GetUSERNAMEIsNull: Boolean; virtual;
    function GetOldUSERNAMEValue: String; virtual;
    function GetOldUSERNAMEIsNull: Boolean; virtual;
    procedure SetUSERNAMEValue(const aValue: String); virtual;
    procedure SetUSERNAMEIsNull(const aValue: Boolean); virtual;
    function GetLOGINValue: String; virtual;
    function GetLOGINIsNull: Boolean; virtual;
    function GetOldLOGINValue: String; virtual;
    function GetOldLOGINIsNull: Boolean; virtual;
    procedure SetLOGINValue(const aValue: String); virtual;
    procedure SetLOGINIsNull(const aValue: Boolean); virtual;
    function GetPASSValue: String; virtual;
    function GetPASSIsNull: Boolean; virtual;
    function GetOldPASSValue: String; virtual;
    function GetOldPASSIsNull: Boolean; virtual;
    procedure SetPASSValue(const aValue: String); virtual;
    procedure SetPASSIsNull(const aValue: Boolean); virtual;
    function GetPASSEXPIREDValue: DateTime; virtual;
    function GetPASSEXPIREDIsNull: Boolean; virtual;
    function GetOldPASSEXPIREDValue: DateTime; virtual;
    function GetOldPASSEXPIREDIsNull: Boolean; virtual;
    procedure SetPASSEXPIREDValue(const aValue: DateTime); virtual;
    procedure SetPASSEXPIREDIsNull(const aValue: Boolean); virtual;
    function GetBLOQUEADOValue: SmallInt; virtual;
    function GetBLOQUEADOIsNull: Boolean; virtual;
    function GetOldBLOQUEADOValue: SmallInt; virtual;
    function GetOldBLOQUEADOIsNull: Boolean; virtual;
    procedure SetBLOQUEADOValue(const aValue: SmallInt); virtual;
    procedure SetBLOQUEADOIsNull(const aValue: Boolean); virtual;
    function GetEMAILValue: String; virtual;
    function GetEMAILIsNull: Boolean; virtual;
    function GetOldEMAILValue: String; virtual;
    function GetOldEMAILIsNull: Boolean; virtual;
    procedure SetEMAILValue(const aValue: String); virtual;
    procedure SetEMAILIsNull(const aValue: Boolean); virtual;
    function GetUSERDAYSSUNValue: Integer; virtual;
    function GetUSERDAYSSUNIsNull: Boolean; virtual;
    function GetOldUSERDAYSSUNValue: Integer; virtual;
    function GetOldUSERDAYSSUNIsNull: Boolean; virtual;
    procedure SetUSERDAYSSUNValue(const aValue: Integer); virtual;
    procedure SetUSERDAYSSUNIsNull(const aValue: Boolean); virtual;
    function GetPRIVILEGEDValue: Integer; virtual;
    function GetPRIVILEGEDIsNull: Boolean; virtual;
    function GetOldPRIVILEGEDValue: Integer; virtual;
    function GetOldPRIVILEGEDIsNull: Boolean; virtual;
    procedure SetPRIVILEGEDValue(const aValue: Integer); virtual;
    procedure SetPRIVILEGEDIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    function GetTIPOIsNull: Boolean; virtual;
    function GetOldTIPOValue: String; virtual;
    function GetOldTIPOIsNull: Boolean; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;
    function GetID_PERFILValue: Integer; virtual;
    function GetID_PERFILIsNull: Boolean; virtual;
    function GetOldID_PERFILValue: Integer; virtual;
    function GetOldID_PERFILIsNull: Boolean; virtual;
    procedure SetID_PERFILValue(const aValue: Integer); virtual;
    procedure SetID_PERFILIsNull(const aValue: Boolean); virtual;
    function GetCHECKSUMValue: String; virtual;
    function GetCHECKSUMIsNull: Boolean; virtual;
    function GetOldCHECKSUMValue: String; virtual;
    function GetOldCHECKSUMIsNull: Boolean; virtual;
    procedure SetCHECKSUMValue(const aValue: String); virtual;
    procedure SetCHECKSUMIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property USERNAME : String read GetUSERNAMEValue write SetUSERNAMEValue;
    property USERNAMEIsNull : Boolean read GetUSERNAMEIsNull write SetUSERNAMEIsNull;
    property OldUSERNAME : String read GetOldUSERNAMEValue;
    property OldUSERNAMEIsNull : Boolean read GetOldUSERNAMEIsNull;
    property LOGIN : String read GetLOGINValue write SetLOGINValue;
    property LOGINIsNull : Boolean read GetLOGINIsNull write SetLOGINIsNull;
    property OldLOGIN : String read GetOldLOGINValue;
    property OldLOGINIsNull : Boolean read GetOldLOGINIsNull;
    property PASS : String read GetPASSValue write SetPASSValue;
    property PASSIsNull : Boolean read GetPASSIsNull write SetPASSIsNull;
    property OldPASS : String read GetOldPASSValue;
    property OldPASSIsNull : Boolean read GetOldPASSIsNull;
    property PASSEXPIRED : DateTime read GetPASSEXPIREDValue write SetPASSEXPIREDValue;
    property PASSEXPIREDIsNull : Boolean read GetPASSEXPIREDIsNull write SetPASSEXPIREDIsNull;
    property OldPASSEXPIRED : DateTime read GetOldPASSEXPIREDValue;
    property OldPASSEXPIREDIsNull : Boolean read GetOldPASSEXPIREDIsNull;
    property BLOQUEADO : SmallInt read GetBLOQUEADOValue write SetBLOQUEADOValue;
    property BLOQUEADOIsNull : Boolean read GetBLOQUEADOIsNull write SetBLOQUEADOIsNull;
    property OldBLOQUEADO : SmallInt read GetOldBLOQUEADOValue;
    property OldBLOQUEADOIsNull : Boolean read GetOldBLOQUEADOIsNull;
    property EMAIL : String read GetEMAILValue write SetEMAILValue;
    property EMAILIsNull : Boolean read GetEMAILIsNull write SetEMAILIsNull;
    property OldEMAIL : String read GetOldEMAILValue;
    property OldEMAILIsNull : Boolean read GetOldEMAILIsNull;
    property USERDAYSSUN : Integer read GetUSERDAYSSUNValue write SetUSERDAYSSUNValue;
    property USERDAYSSUNIsNull : Boolean read GetUSERDAYSSUNIsNull write SetUSERDAYSSUNIsNull;
    property OldUSERDAYSSUN : Integer read GetOldUSERDAYSSUNValue;
    property OldUSERDAYSSUNIsNull : Boolean read GetOldUSERDAYSSUNIsNull;
    property PRIVILEGED : Integer read GetPRIVILEGEDValue write SetPRIVILEGEDValue;
    property PRIVILEGEDIsNull : Boolean read GetPRIVILEGEDIsNull write SetPRIVILEGEDIsNull;
    property OldPRIVILEGED : Integer read GetOldPRIVILEGEDValue;
    property OldPRIVILEGEDIsNull : Boolean read GetOldPRIVILEGEDIsNull;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull : Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property OldTIPO : String read GetOldTIPOValue;
    property OldTIPOIsNull : Boolean read GetOldTIPOIsNull;
    property ID_PERFIL : Integer read GetID_PERFILValue write SetID_PERFILValue;
    property ID_PERFILIsNull : Boolean read GetID_PERFILIsNull write SetID_PERFILIsNull;
    property OldID_PERFIL : Integer read GetOldID_PERFILValue;
    property OldID_PERFILIsNull : Boolean read GetOldID_PERFILIsNull;
    property CHECKSUM : String read GetCHECKSUMValue write SetCHECKSUMValue;
    property CHECKSUMIsNull : Boolean read GetCHECKSUMIsNull write SetCHECKSUMIsNull;
    property OldCHECKSUM : String read GetOldCHECKSUMValue;
    property OldCHECKSUMIsNull : Boolean read GetOldCHECKSUMIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IUSUARIOS_EVENTOSDelta }
  IUSUARIOS_EVENTOSDelta = interface(IUSUARIOS_EVENTOS)
  ['{A9C5CC49-68FB-44C9-82E1-E91B7635E443}']
    { Property getters and setters }
    function GetOldAPLICACIONValue : String;
    function GetOldID_USUARIOValue : Integer;
    function GetOldFECHAValue : String;
    function GetOldHORAValue : String;
    function GetOldFORMValue : String;
    function GetOldTITULO_FORMValue : String;
    function GetOldEVENTOValue : String;
    function GetOldNOTASValue : IROStrings;
    function GetOldTNAMEValue : String;

    { Properties }
    property OldAPLICACION : String read GetOldAPLICACIONValue;
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldFECHA : String read GetOldFECHAValue;
    property OldHORA : String read GetOldHORAValue;
    property OldFORM : String read GetOldFORMValue;
    property OldTITULO_FORM : String read GetOldTITULO_FORMValue;
    property OldEVENTO : String read GetOldEVENTOValue;
    property OldNOTAS : IROStrings read GetOldNOTASValue;
    property OldTNAME : String read GetOldTNAMEValue;
  end;

  { TUSUARIOS_EVENTOSBusinessProcessorRules }
  TUSUARIOS_EVENTOSBusinessProcessorRules = class(TDABusinessProcessorRules, IUSUARIOS_EVENTOS, IUSUARIOS_EVENTOSDelta)
  private
    f_NOTAS: IROStrings;
    procedure NOTAS_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetAPLICACIONValue: String; virtual;
    function GetAPLICACIONIsNull: Boolean; virtual;
    function GetOldAPLICACIONValue: String; virtual;
    function GetOldAPLICACIONIsNull: Boolean; virtual;
    procedure SetAPLICACIONValue(const aValue: String); virtual;
    procedure SetAPLICACIONIsNull(const aValue: Boolean); virtual;
    function GetID_USUARIOValue: Integer; virtual;
    function GetID_USUARIOIsNull: Boolean; virtual;
    function GetOldID_USUARIOValue: Integer; virtual;
    function GetOldID_USUARIOIsNull: Boolean; virtual;
    procedure SetID_USUARIOValue(const aValue: Integer); virtual;
    procedure SetID_USUARIOIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: String; virtual;
    function GetFECHAIsNull: Boolean; virtual;
    function GetOldFECHAValue: String; virtual;
    function GetOldFECHAIsNull: Boolean; virtual;
    procedure SetFECHAValue(const aValue: String); virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetHORAValue: String; virtual;
    function GetHORAIsNull: Boolean; virtual;
    function GetOldHORAValue: String; virtual;
    function GetOldHORAIsNull: Boolean; virtual;
    procedure SetHORAValue(const aValue: String); virtual;
    procedure SetHORAIsNull(const aValue: Boolean); virtual;
    function GetFORMValue: String; virtual;
    function GetFORMIsNull: Boolean; virtual;
    function GetOldFORMValue: String; virtual;
    function GetOldFORMIsNull: Boolean; virtual;
    procedure SetFORMValue(const aValue: String); virtual;
    procedure SetFORMIsNull(const aValue: Boolean); virtual;
    function GetTITULO_FORMValue: String; virtual;
    function GetTITULO_FORMIsNull: Boolean; virtual;
    function GetOldTITULO_FORMValue: String; virtual;
    function GetOldTITULO_FORMIsNull: Boolean; virtual;
    procedure SetTITULO_FORMValue(const aValue: String); virtual;
    procedure SetTITULO_FORMIsNull(const aValue: Boolean); virtual;
    function GetEVENTOValue: String; virtual;
    function GetEVENTOIsNull: Boolean; virtual;
    function GetOldEVENTOValue: String; virtual;
    function GetOldEVENTOIsNull: Boolean; virtual;
    procedure SetEVENTOValue(const aValue: String); virtual;
    procedure SetEVENTOIsNull(const aValue: Boolean); virtual;
    function GetNOTASValue: IROStrings; virtual;
    function GetNOTASIsNull: Boolean; virtual;
    function GetOldNOTASValue: IROStrings; virtual;
    function GetOldNOTASIsNull: Boolean; virtual;
    procedure SetNOTASIsNull(const aValue: Boolean); virtual;
    function GetTNAMEValue: String; virtual;
    function GetTNAMEIsNull: Boolean; virtual;
    function GetOldTNAMEValue: String; virtual;
    function GetOldTNAMEIsNull: Boolean; virtual;
    procedure SetTNAMEValue(const aValue: String); virtual;
    procedure SetTNAMEIsNull(const aValue: Boolean); virtual;

    { Properties }
    property APLICACION : String read GetAPLICACIONValue write SetAPLICACIONValue;
    property APLICACIONIsNull : Boolean read GetAPLICACIONIsNull write SetAPLICACIONIsNull;
    property OldAPLICACION : String read GetOldAPLICACIONValue;
    property OldAPLICACIONIsNull : Boolean read GetOldAPLICACIONIsNull;
    property ID_USUARIO : Integer read GetID_USUARIOValue write SetID_USUARIOValue;
    property ID_USUARIOIsNull : Boolean read GetID_USUARIOIsNull write SetID_USUARIOIsNull;
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldID_USUARIOIsNull : Boolean read GetOldID_USUARIOIsNull;
    property FECHA : String read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull : Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property OldFECHA : String read GetOldFECHAValue;
    property OldFECHAIsNull : Boolean read GetOldFECHAIsNull;
    property HORA : String read GetHORAValue write SetHORAValue;
    property HORAIsNull : Boolean read GetHORAIsNull write SetHORAIsNull;
    property OldHORA : String read GetOldHORAValue;
    property OldHORAIsNull : Boolean read GetOldHORAIsNull;
    property FORM : String read GetFORMValue write SetFORMValue;
    property FORMIsNull : Boolean read GetFORMIsNull write SetFORMIsNull;
    property OldFORM : String read GetOldFORMValue;
    property OldFORMIsNull : Boolean read GetOldFORMIsNull;
    property TITULO_FORM : String read GetTITULO_FORMValue write SetTITULO_FORMValue;
    property TITULO_FORMIsNull : Boolean read GetTITULO_FORMIsNull write SetTITULO_FORMIsNull;
    property OldTITULO_FORM : String read GetOldTITULO_FORMValue;
    property OldTITULO_FORMIsNull : Boolean read GetOldTITULO_FORMIsNull;
    property EVENTO : String read GetEVENTOValue write SetEVENTOValue;
    property EVENTOIsNull : Boolean read GetEVENTOIsNull write SetEVENTOIsNull;
    property OldEVENTO : String read GetOldEVENTOValue;
    property OldEVENTOIsNull : Boolean read GetOldEVENTOIsNull;
    property NOTAS : IROStrings read GetNOTASValue;
    property NOTASIsNull : Boolean read GetNOTASIsNull write SetNOTASIsNull;
    property OldNOTAS : IROStrings read GetOldNOTASValue;
    property OldNOTASIsNull : Boolean read GetOldNOTASIsNull;
    property TNAME : String read GetTNAMEValue write SetTNAMEValue;
    property TNAMEIsNull : Boolean read GetTNAMEIsNull write SetTNAMEIsNull;
    property OldTNAME : String read GetOldTNAMEValue;
    property OldTNAMEIsNull : Boolean read GetOldTNAMEIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IUSUARIOS_LOGONDelta }
  IUSUARIOS_LOGONDelta = interface(IUSUARIOS_LOGON)
  ['{94752363-8D31-4796-A289-07D791FC4A04}']
    { Property getters and setters }
    function GetOldLOGONIDValue : String;
    function GetOldID_USUARIOValue : Integer;
    function GetOldAPLICACIONValue : String;
    function GetOldEQUIPOValue : String;
    function GetOldDATAValue : String;

    { Properties }
    property OldLOGONID : String read GetOldLOGONIDValue;
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldAPLICACION : String read GetOldAPLICACIONValue;
    property OldEQUIPO : String read GetOldEQUIPOValue;
    property OldDATA : String read GetOldDATAValue;
  end;

  { TUSUARIOS_LOGONBusinessProcessorRules }
  TUSUARIOS_LOGONBusinessProcessorRules = class(TDABusinessProcessorRules, IUSUARIOS_LOGON, IUSUARIOS_LOGONDelta)
  private
  protected
    { Property getters and setters }
    function GetLOGONIDValue: String; virtual;
    function GetLOGONIDIsNull: Boolean; virtual;
    function GetOldLOGONIDValue: String; virtual;
    function GetOldLOGONIDIsNull: Boolean; virtual;
    procedure SetLOGONIDValue(const aValue: String); virtual;
    procedure SetLOGONIDIsNull(const aValue: Boolean); virtual;
    function GetID_USUARIOValue: Integer; virtual;
    function GetID_USUARIOIsNull: Boolean; virtual;
    function GetOldID_USUARIOValue: Integer; virtual;
    function GetOldID_USUARIOIsNull: Boolean; virtual;
    procedure SetID_USUARIOValue(const aValue: Integer); virtual;
    procedure SetID_USUARIOIsNull(const aValue: Boolean); virtual;
    function GetAPLICACIONValue: String; virtual;
    function GetAPLICACIONIsNull: Boolean; virtual;
    function GetOldAPLICACIONValue: String; virtual;
    function GetOldAPLICACIONIsNull: Boolean; virtual;
    procedure SetAPLICACIONValue(const aValue: String); virtual;
    procedure SetAPLICACIONIsNull(const aValue: Boolean); virtual;
    function GetEQUIPOValue: String; virtual;
    function GetEQUIPOIsNull: Boolean; virtual;
    function GetOldEQUIPOValue: String; virtual;
    function GetOldEQUIPOIsNull: Boolean; virtual;
    procedure SetEQUIPOValue(const aValue: String); virtual;
    procedure SetEQUIPOIsNull(const aValue: Boolean); virtual;
    function GetDATAValue: String; virtual;
    function GetDATAIsNull: Boolean; virtual;
    function GetOldDATAValue: String; virtual;
    function GetOldDATAIsNull: Boolean; virtual;
    procedure SetDATAValue(const aValue: String); virtual;
    procedure SetDATAIsNull(const aValue: Boolean); virtual;

    { Properties }
    property LOGONID : String read GetLOGONIDValue write SetLOGONIDValue;
    property LOGONIDIsNull : Boolean read GetLOGONIDIsNull write SetLOGONIDIsNull;
    property OldLOGONID : String read GetOldLOGONIDValue;
    property OldLOGONIDIsNull : Boolean read GetOldLOGONIDIsNull;
    property ID_USUARIO : Integer read GetID_USUARIOValue write SetID_USUARIOValue;
    property ID_USUARIOIsNull : Boolean read GetID_USUARIOIsNull write SetID_USUARIOIsNull;
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldID_USUARIOIsNull : Boolean read GetOldID_USUARIOIsNull;
    property APLICACION : String read GetAPLICACIONValue write SetAPLICACIONValue;
    property APLICACIONIsNull : Boolean read GetAPLICACIONIsNull write SetAPLICACIONIsNull;
    property OldAPLICACION : String read GetOldAPLICACIONValue;
    property OldAPLICACIONIsNull : Boolean read GetOldAPLICACIONIsNull;
    property EQUIPO : String read GetEQUIPOValue write SetEQUIPOValue;
    property EQUIPOIsNull : Boolean read GetEQUIPOIsNull write SetEQUIPOIsNull;
    property OldEQUIPO : String read GetOldEQUIPOValue;
    property OldEQUIPOIsNull : Boolean read GetOldEQUIPOIsNull;
    property DATA : String read GetDATAValue write SetDATAValue;
    property DATAIsNull : Boolean read GetDATAIsNull write SetDATAIsNull;
    property OldDATA : String read GetOldDATAValue;
    property OldDATAIsNull : Boolean read GetOldDATAIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IPERMISOSDelta }
  IPERMISOSDelta = interface(IPERMISOS)
  ['{0C3EFDD0-E026-41A9-8411-F879524DC1F6}']
    { Property getters and setters }
    function GetOldID_USUARIOValue : Integer;
    function GetOldMODULOValue : String;
    function GetOldNOMBRECOMPValue : String;
    function GetOldCHECKSUMValue : String;

    { Properties }
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldMODULO : String read GetOldMODULOValue;
    property OldNOMBRECOMP : String read GetOldNOMBRECOMPValue;
    property OldCHECKSUM : String read GetOldCHECKSUMValue;
  end;

  { TPERMISOSBusinessProcessorRules }
  TPERMISOSBusinessProcessorRules = class(TDABusinessProcessorRules, IPERMISOS, IPERMISOSDelta)
  private
  protected
    { Property getters and setters }
    function GetID_USUARIOValue: Integer; virtual;
    function GetID_USUARIOIsNull: Boolean; virtual;
    function GetOldID_USUARIOValue: Integer; virtual;
    function GetOldID_USUARIOIsNull: Boolean; virtual;
    procedure SetID_USUARIOValue(const aValue: Integer); virtual;
    procedure SetID_USUARIOIsNull(const aValue: Boolean); virtual;
    function GetMODULOValue: String; virtual;
    function GetMODULOIsNull: Boolean; virtual;
    function GetOldMODULOValue: String; virtual;
    function GetOldMODULOIsNull: Boolean; virtual;
    procedure SetMODULOValue(const aValue: String); virtual;
    procedure SetMODULOIsNull(const aValue: Boolean); virtual;
    function GetNOMBRECOMPValue: String; virtual;
    function GetNOMBRECOMPIsNull: Boolean; virtual;
    function GetOldNOMBRECOMPValue: String; virtual;
    function GetOldNOMBRECOMPIsNull: Boolean; virtual;
    procedure SetNOMBRECOMPValue(const aValue: String); virtual;
    procedure SetNOMBRECOMPIsNull(const aValue: Boolean); virtual;
    function GetCHECKSUMValue: String; virtual;
    function GetCHECKSUMIsNull: Boolean; virtual;
    function GetOldCHECKSUMValue: String; virtual;
    function GetOldCHECKSUMIsNull: Boolean; virtual;
    procedure SetCHECKSUMValue(const aValue: String); virtual;
    procedure SetCHECKSUMIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID_USUARIO : Integer read GetID_USUARIOValue write SetID_USUARIOValue;
    property ID_USUARIOIsNull : Boolean read GetID_USUARIOIsNull write SetID_USUARIOIsNull;
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldID_USUARIOIsNull : Boolean read GetOldID_USUARIOIsNull;
    property MODULO : String read GetMODULOValue write SetMODULOValue;
    property MODULOIsNull : Boolean read GetMODULOIsNull write SetMODULOIsNull;
    property OldMODULO : String read GetOldMODULOValue;
    property OldMODULOIsNull : Boolean read GetOldMODULOIsNull;
    property NOMBRECOMP : String read GetNOMBRECOMPValue write SetNOMBRECOMPValue;
    property NOMBRECOMPIsNull : Boolean read GetNOMBRECOMPIsNull write SetNOMBRECOMPIsNull;
    property OldNOMBRECOMP : String read GetOldNOMBRECOMPValue;
    property OldNOMBRECOMPIsNull : Boolean read GetOldNOMBRECOMPIsNull;
    property CHECKSUM : String read GetCHECKSUMValue write SetCHECKSUMValue;
    property CHECKSUMIsNull : Boolean read GetCHECKSUMIsNull write SetCHECKSUMIsNull;
    property OldCHECKSUM : String read GetOldCHECKSUMValue;
    property OldCHECKSUMIsNull : Boolean read GetOldCHECKSUMIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IPERMISOSEXDelta }
  IPERMISOSEXDelta = interface(IPERMISOSEX)
  ['{02B025FC-0CFE-41D3-93CF-65E9659AB816}']
    { Property getters and setters }
    function GetOldID_USUARIOValue : Integer;
    function GetOldMODULOValue : String;
    function GetOldNOMBRECOMPValue : String;
    function GetOldNOMBREFORMValue : String;
    function GetOldCHECKSUMValue : String;

    { Properties }
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldMODULO : String read GetOldMODULOValue;
    property OldNOMBRECOMP : String read GetOldNOMBRECOMPValue;
    property OldNOMBREFORM : String read GetOldNOMBREFORMValue;
    property OldCHECKSUM : String read GetOldCHECKSUMValue;
  end;

  { TPERMISOSEXBusinessProcessorRules }
  TPERMISOSEXBusinessProcessorRules = class(TDABusinessProcessorRules, IPERMISOSEX, IPERMISOSEXDelta)
  private
  protected
    { Property getters and setters }
    function GetID_USUARIOValue: Integer; virtual;
    function GetID_USUARIOIsNull: Boolean; virtual;
    function GetOldID_USUARIOValue: Integer; virtual;
    function GetOldID_USUARIOIsNull: Boolean; virtual;
    procedure SetID_USUARIOValue(const aValue: Integer); virtual;
    procedure SetID_USUARIOIsNull(const aValue: Boolean); virtual;
    function GetMODULOValue: String; virtual;
    function GetMODULOIsNull: Boolean; virtual;
    function GetOldMODULOValue: String; virtual;
    function GetOldMODULOIsNull: Boolean; virtual;
    procedure SetMODULOValue(const aValue: String); virtual;
    procedure SetMODULOIsNull(const aValue: Boolean); virtual;
    function GetNOMBRECOMPValue: String; virtual;
    function GetNOMBRECOMPIsNull: Boolean; virtual;
    function GetOldNOMBRECOMPValue: String; virtual;
    function GetOldNOMBRECOMPIsNull: Boolean; virtual;
    procedure SetNOMBRECOMPValue(const aValue: String); virtual;
    procedure SetNOMBRECOMPIsNull(const aValue: Boolean); virtual;
    function GetNOMBREFORMValue: String; virtual;
    function GetNOMBREFORMIsNull: Boolean; virtual;
    function GetOldNOMBREFORMValue: String; virtual;
    function GetOldNOMBREFORMIsNull: Boolean; virtual;
    procedure SetNOMBREFORMValue(const aValue: String); virtual;
    procedure SetNOMBREFORMIsNull(const aValue: Boolean); virtual;
    function GetCHECKSUMValue: String; virtual;
    function GetCHECKSUMIsNull: Boolean; virtual;
    function GetOldCHECKSUMValue: String; virtual;
    function GetOldCHECKSUMIsNull: Boolean; virtual;
    procedure SetCHECKSUMValue(const aValue: String); virtual;
    procedure SetCHECKSUMIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID_USUARIO : Integer read GetID_USUARIOValue write SetID_USUARIOValue;
    property ID_USUARIOIsNull : Boolean read GetID_USUARIOIsNull write SetID_USUARIOIsNull;
    property OldID_USUARIO : Integer read GetOldID_USUARIOValue;
    property OldID_USUARIOIsNull : Boolean read GetOldID_USUARIOIsNull;
    property MODULO : String read GetMODULOValue write SetMODULOValue;
    property MODULOIsNull : Boolean read GetMODULOIsNull write SetMODULOIsNull;
    property OldMODULO : String read GetOldMODULOValue;
    property OldMODULOIsNull : Boolean read GetOldMODULOIsNull;
    property NOMBRECOMP : String read GetNOMBRECOMPValue write SetNOMBRECOMPValue;
    property NOMBRECOMPIsNull : Boolean read GetNOMBRECOMPIsNull write SetNOMBRECOMPIsNull;
    property OldNOMBRECOMP : String read GetOldNOMBRECOMPValue;
    property OldNOMBRECOMPIsNull : Boolean read GetOldNOMBRECOMPIsNull;
    property NOMBREFORM : String read GetNOMBREFORMValue write SetNOMBREFORMValue;
    property NOMBREFORMIsNull : Boolean read GetNOMBREFORMIsNull write SetNOMBREFORMIsNull;
    property OldNOMBREFORM : String read GetOldNOMBREFORMValue;
    property OldNOMBREFORMIsNull : Boolean read GetOldNOMBREFORMIsNull;
    property CHECKSUM : String read GetCHECKSUMValue write SetCHECKSUMValue;
    property CHECKSUMIsNull : Boolean read GetCHECKSUMIsNull write SetCHECKSUMIsNull;
    property OldCHECKSUM : String read GetOldCHECKSUMValue;
    property OldCHECKSUMIsNull : Boolean read GetOldCHECKSUMIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IPERFILESDelta }
  IPERFILESDelta = interface(IPERFILES)
  ['{00782C74-631D-4032-8177-FBA0607AA4DD}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldUSERNAMEValue : String;
    function GetOldLOGINValue : String;
    function GetOldTIPOValue : String;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldUSERNAME : String read GetOldUSERNAMEValue;
    property OldLOGIN : String read GetOldLOGINValue;
    property OldTIPO : String read GetOldTIPOValue;
  end;

  { TPERFILESBusinessProcessorRules }
  TPERFILESBusinessProcessorRules = class(TDABusinessProcessorRules, IPERFILES, IPERFILESDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetUSERNAMEValue: String; virtual;
    function GetUSERNAMEIsNull: Boolean; virtual;
    function GetOldUSERNAMEValue: String; virtual;
    function GetOldUSERNAMEIsNull: Boolean; virtual;
    procedure SetUSERNAMEValue(const aValue: String); virtual;
    procedure SetUSERNAMEIsNull(const aValue: Boolean); virtual;
    function GetLOGINValue: String; virtual;
    function GetLOGINIsNull: Boolean; virtual;
    function GetOldLOGINValue: String; virtual;
    function GetOldLOGINIsNull: Boolean; virtual;
    procedure SetLOGINValue(const aValue: String); virtual;
    procedure SetLOGINIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    function GetTIPOIsNull: Boolean; virtual;
    function GetOldTIPOValue: String; virtual;
    function GetOldTIPOIsNull: Boolean; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property USERNAME : String read GetUSERNAMEValue write SetUSERNAMEValue;
    property USERNAMEIsNull : Boolean read GetUSERNAMEIsNull write SetUSERNAMEIsNull;
    property OldUSERNAME : String read GetOldUSERNAMEValue;
    property OldUSERNAMEIsNull : Boolean read GetOldUSERNAMEIsNull;
    property LOGIN : String read GetLOGINValue write SetLOGINValue;
    property LOGINIsNull : Boolean read GetLOGINIsNull write SetLOGINIsNull;
    property OldLOGIN : String read GetOldLOGINValue;
    property OldLOGINIsNull : Boolean read GetOldLOGINIsNull;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull : Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property OldTIPO : String read GetOldTIPOValue;
    property OldTIPOIsNull : Boolean read GetOldTIPOIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ TUSUARIOSBusinessProcessorRules }
constructor TUSUARIOSBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TUSUARIOSBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TUSUARIOSBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID];
end;

function TUSUARIOSBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSID];
end;

function TUSUARIOSBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSID]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetUSERNAMEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERNAME];
end;

function TUSUARIOSBusinessProcessorRules.GetUSERNAMEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERNAME]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldUSERNAMEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSUSERNAME];
end;

function TUSUARIOSBusinessProcessorRules.GetOldUSERNAMEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSUSERNAME]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetUSERNAMEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERNAME] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetUSERNAMEIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERNAME] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetLOGINValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSLOGIN];
end;

function TUSUARIOSBusinessProcessorRules.GetLOGINIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSLOGIN]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldLOGINValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSLOGIN];
end;

function TUSUARIOSBusinessProcessorRules.GetOldLOGINIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSLOGIN]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetLOGINValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSLOGIN] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetLOGINIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSLOGIN] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetPASSValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASS];
end;

function TUSUARIOSBusinessProcessorRules.GetPASSIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASS]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldPASSValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSPASS];
end;

function TUSUARIOSBusinessProcessorRules.GetOldPASSIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSPASS]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetPASSValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASS] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetPASSIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASS] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetPASSEXPIREDValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASSEXPIRED];
end;

function TUSUARIOSBusinessProcessorRules.GetPASSEXPIREDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASSEXPIRED]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldPASSEXPIREDValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSPASSEXPIRED];
end;

function TUSUARIOSBusinessProcessorRules.GetOldPASSEXPIREDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSPASSEXPIRED]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetPASSEXPIREDValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASSEXPIRED] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetPASSEXPIREDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPASSEXPIRED] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetBLOQUEADOValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSBLOQUEADO];
end;

function TUSUARIOSBusinessProcessorRules.GetBLOQUEADOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSBLOQUEADO]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldBLOQUEADOValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSBLOQUEADO];
end;

function TUSUARIOSBusinessProcessorRules.GetOldBLOQUEADOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSBLOQUEADO]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetBLOQUEADOValue(const aValue: SmallInt);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSBLOQUEADO] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetBLOQUEADOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSBLOQUEADO] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetEMAILValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSEMAIL];
end;

function TUSUARIOSBusinessProcessorRules.GetEMAILIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSEMAIL]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldEMAILValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSEMAIL];
end;

function TUSUARIOSBusinessProcessorRules.GetOldEMAILIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSEMAIL]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetEMAILValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSEMAIL] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetEMAILIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSEMAIL] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetUSERDAYSSUNValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERDAYSSUN];
end;

function TUSUARIOSBusinessProcessorRules.GetUSERDAYSSUNIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERDAYSSUN]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldUSERDAYSSUNValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSUSERDAYSSUN];
end;

function TUSUARIOSBusinessProcessorRules.GetOldUSERDAYSSUNIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSUSERDAYSSUN]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetUSERDAYSSUNValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERDAYSSUN] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetUSERDAYSSUNIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSUSERDAYSSUN] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetPRIVILEGEDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPRIVILEGED];
end;

function TUSUARIOSBusinessProcessorRules.GetPRIVILEGEDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPRIVILEGED]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldPRIVILEGEDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSPRIVILEGED];
end;

function TUSUARIOSBusinessProcessorRules.GetOldPRIVILEGEDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSPRIVILEGED]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetPRIVILEGEDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPRIVILEGED] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetPRIVILEGEDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSPRIVILEGED] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSTIPO];
end;

function TUSUARIOSBusinessProcessorRules.GetTIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSTIPO]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSTIPO];
end;

function TUSUARIOSBusinessProcessorRules.GetOldTIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSTIPO]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSTIPO] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSTIPO] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetID_PERFILValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID_PERFIL];
end;

function TUSUARIOSBusinessProcessorRules.GetID_PERFILIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID_PERFIL]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldID_PERFILValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSID_PERFIL];
end;

function TUSUARIOSBusinessProcessorRules.GetOldID_PERFILIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSID_PERFIL]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetID_PERFILValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID_PERFIL] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetID_PERFILIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSID_PERFIL] := Null;
end;

function TUSUARIOSBusinessProcessorRules.GetCHECKSUMValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSCHECKSUM];
end;

function TUSUARIOSBusinessProcessorRules.GetCHECKSUMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSCHECKSUM]);
end;

function TUSUARIOSBusinessProcessorRules.GetOldCHECKSUMValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSCHECKSUM];
end;

function TUSUARIOSBusinessProcessorRules.GetOldCHECKSUMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOSCHECKSUM]);
end;

procedure TUSUARIOSBusinessProcessorRules.SetCHECKSUMValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSCHECKSUM] := aValue;
end;

procedure TUSUARIOSBusinessProcessorRules.SetCHECKSUMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOSCHECKSUM] := Null;
end;


{ TUSUARIOS_EVENTOSBusinessProcessorRules }
constructor TUSUARIOS_EVENTOSBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := NOTAS_OnChange;
  f_NOTAS := NewROStrings(StrList,True);
end;

destructor TUSUARIOS_EVENTOSBusinessProcessorRules.Destroy;
begin
  inherited;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.NOTAS_OnChange(Sender: TObject);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSNOTAS] := TStringList(Sender).Text;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetAPLICACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSAPLICACION];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetAPLICACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSAPLICACION]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldAPLICACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSAPLICACION];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldAPLICACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSAPLICACION]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetAPLICACIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSAPLICACION] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetAPLICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSAPLICACION] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSID_USUARIO];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSID_USUARIO]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSID_USUARIO];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSID_USUARIO]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetID_USUARIOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSID_USUARIO] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetID_USUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSID_USUARIO] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetFECHAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFECHA];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFECHA]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldFECHAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSFECHA];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSFECHA]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetFECHAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFECHA] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFECHA] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetHORAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSHORA];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetHORAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSHORA]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldHORAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSHORA];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldHORAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSHORA]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetHORAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSHORA] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetHORAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSHORA] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetFORMValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFORM];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetFORMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFORM]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldFORMValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSFORM];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldFORMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSFORM]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetFORMValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFORM] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetFORMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSFORM] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetTITULO_FORMValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTITULO_FORM];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetTITULO_FORMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTITULO_FORM]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldTITULO_FORMValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSTITULO_FORM];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldTITULO_FORMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSTITULO_FORM]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetTITULO_FORMValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTITULO_FORM] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetTITULO_FORMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTITULO_FORM] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetEVENTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSEVENTO];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetEVENTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSEVENTO]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldEVENTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSEVENTO];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldEVENTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSEVENTO]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetEVENTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSEVENTO] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetEVENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSEVENTO] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetNOTASValue: IROStrings;
begin
  result := f_NOTAS;
  result.Text := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSNOTAS];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetNOTASIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSNOTAS]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldNOTASValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSNOTAS];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldNOTASIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSNOTAS]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetNOTASIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSNOTAS] := Null;
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetTNAMEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTNAME];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetTNAMEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTNAME]);
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldTNAMEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSTNAME];
end;

function TUSUARIOS_EVENTOSBusinessProcessorRules.GetOldTNAMEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_EVENTOSTNAME]);
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetTNAMEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTNAME] := aValue;
end;

procedure TUSUARIOS_EVENTOSBusinessProcessorRules.SetTNAMEIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_EVENTOSTNAME] := Null;
end;


{ TUSUARIOS_LOGONBusinessProcessorRules }
constructor TUSUARIOS_LOGONBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TUSUARIOS_LOGONBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetLOGONIDValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONLOGONID];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetLOGONIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONLOGONID]);
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldLOGONIDValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONLOGONID];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldLOGONIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONLOGONID]);
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetLOGONIDValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONLOGONID] := aValue;
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetLOGONIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONLOGONID] := Null;
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONID_USUARIO];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONID_USUARIO]);
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONID_USUARIO];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONID_USUARIO]);
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetID_USUARIOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONID_USUARIO] := aValue;
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetID_USUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONID_USUARIO] := Null;
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetAPLICACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONAPLICACION];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetAPLICACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONAPLICACION]);
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldAPLICACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONAPLICACION];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldAPLICACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONAPLICACION]);
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetAPLICACIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONAPLICACION] := aValue;
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetAPLICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONAPLICACION] := Null;
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetEQUIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONEQUIPO];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetEQUIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONEQUIPO]);
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldEQUIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONEQUIPO];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldEQUIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONEQUIPO]);
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetEQUIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONEQUIPO] := aValue;
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetEQUIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONEQUIPO] := Null;
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetDATAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONDATA];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetDATAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONDATA]);
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldDATAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONDATA];
end;

function TUSUARIOS_LOGONBusinessProcessorRules.GetOldDATAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_USUARIOS_LOGONDATA]);
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetDATAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONDATA] := aValue;
end;

procedure TUSUARIOS_LOGONBusinessProcessorRules.SetDATAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_USUARIOS_LOGONDATA] := Null;
end;


{ TPERMISOSBusinessProcessorRules }
constructor TPERMISOSBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TPERMISOSBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TPERMISOSBusinessProcessorRules.GetID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSID_USUARIO];
end;

function TPERMISOSBusinessProcessorRules.GetID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSID_USUARIO]);
end;

function TPERMISOSBusinessProcessorRules.GetOldID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSID_USUARIO];
end;

function TPERMISOSBusinessProcessorRules.GetOldID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSID_USUARIO]);
end;

procedure TPERMISOSBusinessProcessorRules.SetID_USUARIOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSID_USUARIO] := aValue;
end;

procedure TPERMISOSBusinessProcessorRules.SetID_USUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSID_USUARIO] := Null;
end;

function TPERMISOSBusinessProcessorRules.GetMODULOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSMODULO];
end;

function TPERMISOSBusinessProcessorRules.GetMODULOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSMODULO]);
end;

function TPERMISOSBusinessProcessorRules.GetOldMODULOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSMODULO];
end;

function TPERMISOSBusinessProcessorRules.GetOldMODULOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSMODULO]);
end;

procedure TPERMISOSBusinessProcessorRules.SetMODULOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSMODULO] := aValue;
end;

procedure TPERMISOSBusinessProcessorRules.SetMODULOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSMODULO] := Null;
end;

function TPERMISOSBusinessProcessorRules.GetNOMBRECOMPValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSNOMBRECOMP];
end;

function TPERMISOSBusinessProcessorRules.GetNOMBRECOMPIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSNOMBRECOMP]);
end;

function TPERMISOSBusinessProcessorRules.GetOldNOMBRECOMPValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSNOMBRECOMP];
end;

function TPERMISOSBusinessProcessorRules.GetOldNOMBRECOMPIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSNOMBRECOMP]);
end;

procedure TPERMISOSBusinessProcessorRules.SetNOMBRECOMPValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSNOMBRECOMP] := aValue;
end;

procedure TPERMISOSBusinessProcessorRules.SetNOMBRECOMPIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSNOMBRECOMP] := Null;
end;

function TPERMISOSBusinessProcessorRules.GetCHECKSUMValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSCHECKSUM];
end;

function TPERMISOSBusinessProcessorRules.GetCHECKSUMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSCHECKSUM]);
end;

function TPERMISOSBusinessProcessorRules.GetOldCHECKSUMValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSCHECKSUM];
end;

function TPERMISOSBusinessProcessorRules.GetOldCHECKSUMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSCHECKSUM]);
end;

procedure TPERMISOSBusinessProcessorRules.SetCHECKSUMValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSCHECKSUM] := aValue;
end;

procedure TPERMISOSBusinessProcessorRules.SetCHECKSUMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSCHECKSUM] := Null;
end;


{ TPERMISOSEXBusinessProcessorRules }
constructor TPERMISOSEXBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TPERMISOSEXBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TPERMISOSEXBusinessProcessorRules.GetID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXID_USUARIO];
end;

function TPERMISOSEXBusinessProcessorRules.GetID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXID_USUARIO]);
end;

function TPERMISOSEXBusinessProcessorRules.GetOldID_USUARIOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXID_USUARIO];
end;

function TPERMISOSEXBusinessProcessorRules.GetOldID_USUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXID_USUARIO]);
end;

procedure TPERMISOSEXBusinessProcessorRules.SetID_USUARIOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXID_USUARIO] := aValue;
end;

procedure TPERMISOSEXBusinessProcessorRules.SetID_USUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXID_USUARIO] := Null;
end;

function TPERMISOSEXBusinessProcessorRules.GetMODULOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXMODULO];
end;

function TPERMISOSEXBusinessProcessorRules.GetMODULOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXMODULO]);
end;

function TPERMISOSEXBusinessProcessorRules.GetOldMODULOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXMODULO];
end;

function TPERMISOSEXBusinessProcessorRules.GetOldMODULOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXMODULO]);
end;

procedure TPERMISOSEXBusinessProcessorRules.SetMODULOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXMODULO] := aValue;
end;

procedure TPERMISOSEXBusinessProcessorRules.SetMODULOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXMODULO] := Null;
end;

function TPERMISOSEXBusinessProcessorRules.GetNOMBRECOMPValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBRECOMP];
end;

function TPERMISOSEXBusinessProcessorRules.GetNOMBRECOMPIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBRECOMP]);
end;

function TPERMISOSEXBusinessProcessorRules.GetOldNOMBRECOMPValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXNOMBRECOMP];
end;

function TPERMISOSEXBusinessProcessorRules.GetOldNOMBRECOMPIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXNOMBRECOMP]);
end;

procedure TPERMISOSEXBusinessProcessorRules.SetNOMBRECOMPValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBRECOMP] := aValue;
end;

procedure TPERMISOSEXBusinessProcessorRules.SetNOMBRECOMPIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBRECOMP] := Null;
end;

function TPERMISOSEXBusinessProcessorRules.GetNOMBREFORMValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBREFORM];
end;

function TPERMISOSEXBusinessProcessorRules.GetNOMBREFORMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBREFORM]);
end;

function TPERMISOSEXBusinessProcessorRules.GetOldNOMBREFORMValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXNOMBREFORM];
end;

function TPERMISOSEXBusinessProcessorRules.GetOldNOMBREFORMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXNOMBREFORM]);
end;

procedure TPERMISOSEXBusinessProcessorRules.SetNOMBREFORMValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBREFORM] := aValue;
end;

procedure TPERMISOSEXBusinessProcessorRules.SetNOMBREFORMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXNOMBREFORM] := Null;
end;

function TPERMISOSEXBusinessProcessorRules.GetCHECKSUMValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXCHECKSUM];
end;

function TPERMISOSEXBusinessProcessorRules.GetCHECKSUMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXCHECKSUM]);
end;

function TPERMISOSEXBusinessProcessorRules.GetOldCHECKSUMValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXCHECKSUM];
end;

function TPERMISOSEXBusinessProcessorRules.GetOldCHECKSUMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERMISOSEXCHECKSUM]);
end;

procedure TPERMISOSEXBusinessProcessorRules.SetCHECKSUMValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXCHECKSUM] := aValue;
end;

procedure TPERMISOSEXBusinessProcessorRules.SetCHECKSUMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERMISOSEXCHECKSUM] := Null;
end;


{ TPERFILESBusinessProcessorRules }
constructor TPERFILESBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TPERFILESBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TPERFILESBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESID];
end;

function TPERFILESBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESID]);
end;

function TPERFILESBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESID];
end;

function TPERFILESBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESID]);
end;

procedure TPERFILESBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESID] := aValue;
end;

procedure TPERFILESBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESID] := Null;
end;

function TPERFILESBusinessProcessorRules.GetUSERNAMEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESUSERNAME];
end;

function TPERFILESBusinessProcessorRules.GetUSERNAMEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESUSERNAME]);
end;

function TPERFILESBusinessProcessorRules.GetOldUSERNAMEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESUSERNAME];
end;

function TPERFILESBusinessProcessorRules.GetOldUSERNAMEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESUSERNAME]);
end;

procedure TPERFILESBusinessProcessorRules.SetUSERNAMEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESUSERNAME] := aValue;
end;

procedure TPERFILESBusinessProcessorRules.SetUSERNAMEIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESUSERNAME] := Null;
end;

function TPERFILESBusinessProcessorRules.GetLOGINValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESLOGIN];
end;

function TPERFILESBusinessProcessorRules.GetLOGINIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESLOGIN]);
end;

function TPERFILESBusinessProcessorRules.GetOldLOGINValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESLOGIN];
end;

function TPERFILESBusinessProcessorRules.GetOldLOGINIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESLOGIN]);
end;

procedure TPERFILESBusinessProcessorRules.SetLOGINValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESLOGIN] := aValue;
end;

procedure TPERFILESBusinessProcessorRules.SetLOGINIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESLOGIN] := Null;
end;

function TPERFILESBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESTIPO];
end;

function TPERFILESBusinessProcessorRules.GetTIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESTIPO]);
end;

function TPERFILESBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESTIPO];
end;

function TPERFILESBusinessProcessorRules.GetOldTIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_PERFILESTIPO]);
end;

procedure TPERFILESBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESTIPO] := aValue;
end;

procedure TPERFILESBusinessProcessorRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_PERFILESTIPO] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID_USUARIOSDelta, TUSUARIOSBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_USUARIOS_EVENTOSDelta, TUSUARIOS_EVENTOSBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_USUARIOS_LOGONDelta, TUSUARIOS_LOGONBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_PERMISOSDelta, TPERMISOSBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_PERMISOSEXDelta, TPERMISOSEXBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_PERFILESDelta, TPERFILESBusinessProcessorRules);

end.
